  // extends nsMsgViewSortType.xxx, they have values from 17 to 33
const MsgViewSortType_inout         = 34;
const MsgViewSortType_inoutaddress  = 35;

/* keep in sync with mailnews/base/public/nsMsgFolderFlags.h */
//const MSG_FOLDER_FLAG_VIRTUAL = 0x0020;

var gsio_tree_view;
var gMyAddr=new Object;
var gHeaderParser = Components.classes["@mozilla.org/messenger/headerparser;1"].
        getService(Components.interfaces.nsIMsgHeaderParser);

var sioData = new Object;
var sioAddr = new Object;


function sio_init() {

  /*
   *  Move the elements from our additional treecols to the main treecols
   *  They have to be insertet in increasding order of ordinal!
   *  May produce incorrect results, if other extensions also inserts columns!
   */
  var tree=document.getElementById('threadTree');
  var treecols=tree.firstChild;
  var newcols=document.getElementById('sio_additionalCols');
  if (!newcols) {
dump('sio init delayed!\n');
    setTimeout(sio_init, 1000);
    return;
  }
dump('sio init\n');

/*
 * Insert new cols into the tree
 */
  // get positions of normal elements
  var posNormal=new Array;
  var colNodes=treecols.childNodes;
  for (var i=0; i<colNodes.length; i++) {
    var col=colNodes[i];
    if (col.nodeName=="treecol") {
      posNormal[col.ordinal]=col;
//dump(col.id+' '+col.ordinal+'\n');
    }
  }
  // get positions of my additional elements
  var posNew=new Array;
  var splitters=new Array;
  colNodes=newcols.childNodes;
  for (var i=0; i<colNodes.length; i++) {
    var col=colNodes[i];
    if (col.nodeName=="treecol") {
      posNew[col.ordinal]=col;
//dump(col.id+' '+col.ordinal+'\n');
    } else
      splitters.push(col);
  }

  //append new cols and move into the right position
  var offset=0;
  for (var i=0; i<posNew.length; i++) {
    var node;
    if (!(node=posNew[i])) continue;
    var splitter=splitters.shift();
    treecols.appendChild(splitter);
    treecols.appendChild(node);
    splitter.ordinal=100;
    node.ordinal=101;
    var insertHere=i<posNormal.length?posNormal[i-offset]:posNormal[posNormal.length-1];
//dump('insert '+node.id+' before '+insertHere.id+'('+insertHere.ordinal+', '+(i<posNormal.length)+')'+'\n');
      //undocumented functions from toolkit\content\global\bindings\tree.xml
//    tree._columnsDirty=true;
    tree._reorderColumn(node, insertHere, i<posNormal.length);
    offset+=2;
  }
  tree.removeChild(newcols);

/*
dump('---\n');
var c=treecols.childNodes;
for (var i=0; i<c.length; i++) {
  var col=c[i];
  if (col.nodeName=="treecol")
dump(col.id+' '+col.ordinal+'\n');
}
*/

/*
 *  Find all email addresses, which count as mine
 */
  var accountMgr=
    Components.classes["@mozilla.org/messenger/account-manager;1"].
      getService(Components.interfaces.nsIMsgAccountManager);
  var allAccounts=accountMgr.accounts;
  var accountsCount = allAccounts.Count();
  for (var i = 0; i < accountsCount; i++) {
    var account = allAccounts.QueryElementAt(i, Components.interfaces.nsIMsgAccount);
    var allIdentities=account.identities;
    identitiesCount = allIdentities.Count();
    for (var j = 0; j < identitiesCount; j++) {
      var identity = allIdentities.QueryElementAt(j, Components.interfaces.nsIMsgIdentity);
      if (gMyAddr[identity.email]===undefined)
        gMyAddr[identity.email]=1;
//dump(identity.email+'\n');
    }
  }

}

function extractName(email) {
  email=gHeaderParser.unquotePhraseOrAddrWString(email, true);
  var p=email.indexOf('"');
  if (p>=0) {  // "name" <email>
    var pe=email.indexOf('"',p+1);
    return email.substring(p+1,pe);
  }
  p=email.indexOf('<');
  if (p>0) { // name <email>
    return email.substring(0,p-1);
  } else if (p==0) {
    var pe=email.indexOf('>',p+1);
    return email.substring(p+1,pe);
  }
  return email;
}

function getMsgInfo(row, messageURI) {
  var msgFolder=gsio_tree_view.wrapped_view.getFolderForViewIndex(row);
  var key=gsio_tree_view.wrapped_view.getKeyAt(row);
  var msgHdr=msgFolder.GetMessageHeader(key);
  // extract just the mail address from the author and compare to the list of 'my' Addresses
  var author = gHeaderParser.extractHeaderAddressMailboxes(null, msgHdr.author);
  var received=gMyAddr[author]===undefined?'in':'out';

  sioData[messageURI]=received;

//    sioAddr[messageURI]=received=='in' ? msgHdr.author : msgHdr.recipients;
  sioAddr[messageURI] = received=='in' ?
      extractName(msgHdr.mime2DecodedAuthor)  :
      extractName(msgHdr.mime2DecodedRecipients) ;
}


function sio_msg_tree_view() {}

sio_msg_tree_view.prototype = {

   // The wrapped nsITreeView (nsIMsgDBView) object.
  wrapped_view : null,

  getCellProperties : function( row , col , properties )   //called
  {
    if(col.id == "sio_inoutCol") {
      var messageURI = this.wrapped_view.getURIForViewIndex(row);
      if (sioData[messageURI] === undefined) {
        getMsgInfo(row, messageURI);
      }
      var received=sioData[messageURI];
        //properties already defined:
        //    focus, [leaf|container], [even|odd], sio_inoutCol
        //  appending [in|out]
      if (received!==null) {
        var aserv=Components.classes["@mozilla.org/atom-service;1"].
                  getService(Components.interfaces.nsIAtomService);
        properties.AppendElement(aserv.getAtom(received));
      }
      return;
    }
    return this.wrapped_view.getCellProperties ( row , col , properties )
  },
  getCellText : function(row, col)
  {
    if (col.id == "sio_inoutCol")
      return '';
    else if (col.id == "sio_inoutaddressCol") {
      var messageURI = this.wrapped_view.getURIForViewIndex(row);
      if (sioData[messageURI] === undefined)
        getMsgInfo(row, messageURI);
      return sioAddr[messageURI];
    }
var val=this.wrapped_view.getCellText(row, col);
var key=this.wrapped_view.getKeyAt(row);
if (col.id == "senderCol") {
  sioAddr[key]=val;
} else if (col.id == "recipientCol") {
  sioAddr[key]=val;
}
return val;
    return this.wrapped_view.getCellText(row, col);
  },
  getImageSrc : function ( row , col )
  {
/*
    if (col.id == "sio_inoutaddressCol") {  //called!!
      // image inserted in front of the text, returned in getCellText
      return "chrome://showInOut/skin/out.png";
    }
*/
    return this.wrapped_view.getImageSrc ( row , col )
  },
  setTree : function ( tree ) //called
  { // seems to be called, when a new folder is selected
    dump('setTree\n');
    sioData=new Object;
    sioAddr=new Object;
    return this.wrapped_view.setTree ( tree )
  },


  ////////////////////////////////////////////////////

   // Redefine QueryInterface().
  QueryInterface : function(iid)
  {
    if(iid.equals(Components.interfaces.nsITreeView) || iid.equals(Components.interfaces.nsISupports))
          return this;

    throw Components.results.NS_NOINTERFACE;
  },

   // Wrapped constants

  DROP_BEFORE : Components.interfaces.nsITreeView.DROP_BEFORE,
 	DROP_ON : Components.interfaces.nsITreeView.DROP_ON,
 	DROP_AFTER : Components.interfaces.nsITreeView.DROP_AFTER,
 	PROGRESS_NORMAL : Components.interfaces.nsITreeView.PROGRESS_NORMAL,
 	PROGRESS_UNDETERMINED : Components.interfaces.nsITreeView.PROGRESS_UNDETERMINED,
 	PROGRESS_NONE : Components.interfaces.nsITreeView.PROGRESS_NONE,

   // Wrapped properties

  get rowCount() {
//    dump('get rowCount\n');
    return this.wrapped_view['rowCount'];
  },
  set rowCount(val) {
//    dump('set rowCount\n');
    this.wrapped_view['rowCount'] = val;
  },

  get selection() {   //called
//    dump('get selection\n');
    return this.wrapped_view['selection'];
  },
  set selection(sel) {
//    dump('set selection\n');
    this.wrapped_view['selection'] = sel;
  },

   // Wrapped methods

  canDrop : function(index, orientation)
  {
//    dump('canDrop\n');
    return this.wrapped_view.canDrop(index, orientation);
  },
  cycleCell : function( row , col )
  {
//    dump('cycleCell\n');
    return this.wrapped_view.cycleCell ( row , col )
  },
  cycleHeader : function( col )
  {
//    dump('cycleHeader\n');
    return this.wrapped_view.cycleHeader ( col )
  },
  drop : function( row , orientation )
  {
//    dump('drop\n');
    return this.wrapped_view.drop ( row , orientation )
  },
/*
  getCellProperties : function( row , col , properties )   //called
  {
//    dump('getCellProperties\n');
    return this.wrapped_view.getCellProperties ( row , col , properties )
  },
*/
/*
  getCellText : function ( row , col )
  {
//    dump('getCellText\n');
    return this.wrapped_view.getCellText ( row , col )
  },
*/
  getCellValue : function ( row , col )
  {
//    dump('getCellValue\n');
    return this.wrapped_view.getCellValue ( row , col )
  },
  getColumnProperties : function ( col , properties )
  {
//    dump('getColumnProperties\n');
    return this.wrapped_view.getColumnProperties ( col , properties )
  },
/*
  getImageSrc : function ( row , col )   //called
  {
//    dump('getImageSrc\n');
    return this.wrapped_view.getImageSrc ( row , col )
  },
*/
  getLevel : function ( index )   //called
  {
//    dump('getLevel\n');
    return this.wrapped_view.getLevel ( index )
  },
  getParentIndex : function ( rowIndex )
  {
//    dump('getParentIndex\n');
    return this.wrapped_view.getParentIndex ( rowIndex )
  },
  getProgressMode : function ( row , col )
  {
//    dump('getProgressMode\n');
    return this.wrapped_view.getProgressMode ( row , col )
  },
  getRowProperties : function ( index , properties )
  {
//    dump('getRowProperties\n');
    return this.wrapped_view.getRowProperties ( index , properties )
  },
  hasNextSibling : function ( rowIndex , afterIndex )
  {
//    dump('hasNextSibling\n');
    return this.wrapped_view.hasNextSibling ( rowIndex , afterIndex )
  },
  isContainer : function ( index )   //called
  {
//    dump('isContainer\n');
    return this.wrapped_view.isContainer ( index )
  },
  isContainerEmpty : function ( index )
  {
//    dump('isContainerEmpty\n');
    return this.wrapped_view.isContainerEmpty ( index )
  },
  isContainerOpen : function ( index )
  {
//    dump('isContainerOpen\n');
    return this.wrapped_view.isContainerOpen ( index )
  },
  isEditable : function ( row , col )
  {
//    dump('isEditable\n');
    return this.wrapped_view.isEditable ( row , col )
  },
  isSeparator : function ( index )
  {
//    dump('isSeparator\n');
    return this.wrapped_view.isSeparator ( index )
  },
  isSorted : function ( ) //called
  {
//    dump('isSorted\n');
    return this.wrapped_view.isSorted ( )
  },
  performAction : function ( action )
  {
//    dump('performAction\n');
    return this.wrapped_view.performAction ( action )
  },
  performActionOnCell : function ( action , row , col )
  {
//    dump('performActionOnCell\n');
    return this.wrapped_view.performActionOnCell ( action , row , col )
  },
  performActionOnRow : function ( action , row )
  {
//    dump('performActionOnRow\n');
    return this.wrapped_view.performActionOnRow ( action , row )
  },
  selectionChanged : function ( )
  {
//    dump('selectionChanged\n');
    return this.wrapped_view.selectionChanged ( )
  },
  setCellText : function ( row , col , value )
  {
    dump('setCellText row='+row+'col='+col.id+'\n');
    return this.wrapped_view.setCellText ( row , col , value )
  },
  setCellValue : function ( row , col , value )
  {
    dump('setCellValue row='+row+'col='+col.id+'value='+value+'\n');
    return this.wrapped_view.setCellValue ( row , col , value )
  },
/*
  setTree : function ( tree ) //called
  {
    dump('setTree\n');
    return this.wrapped_view.setTree ( tree )
  },
*/
  toggleOpenState : function ( index )
  {
    dump('toggleOpenState\n');
    return this.wrapped_view.toggleOpenState ( index )
  }
};
///////////////////////////////////////////////////////////////////
/*
 * Overlay from threadPane.js@506
 */
function RerootThreadPane()
{
   SetNewsFolderColumns();
   var tb_tree_view = gDBView.QueryInterface(Components.interfaces.nsITreeView);
   if(tb_tree_view)
   {
      // Create the wrapper.
      gsio_tree_view = new sio_msg_tree_view();
      gsio_tree_view.wrapped_view = tb_tree_view;

      // Set the wrapper.
      var tree = GetThreadTree();
      tree.boxObject.QueryInterface(Components.interfaces.nsITreeBoxObject).view = gsio_tree_view;
   }
}

/*
 *  Overload functions in commandglue.js
 */
/*v sort does not work
function ConvertColumnIDToSortType(columnID)
{
  var sortKey;

  switch (columnID) {
    case "sio_inoutCol":
      sortKey = MsgViewSortType_inout;
      break;
    case "sio_inoutaddressCol":
      sortKey = MsgViewSortType_inoutaddress;
      break;
    default:
      sortKey=savedConvertColumnIDToSortType(columnID);
      break;
  }
dump('ID->Type: '+columnID+' -> '+sortKey+'\n');
  return sortKey;
}
function ConvertSortTypeToColumnID(sortKey)
{
  var columnID;

  // hack to turn this into an integer, if it was a string
  // it would be a string if it came from localStore.rdf
  sortKey = sortKey - 0;

  switch (sortKey) {
    case MsgViewSortType_inout:
      columnID = "sio_inoutCol";
      break;
    case MsgViewSortType_inoutaddress:
      columnID = "sio_inoutaddressCol";
      break;
    default:
      columnID = savedConvertSortTypeToColumnID(sortKey);
      break;
  }
dump('Type->ID: '+sortKey+' -> '+columnID+'\n');
  return columnID;
}
^*/

// To be called when extending menu 'view/sortBy'
function MsgSortByInout()
{
    MsgSortThreadPane(MsgViewSortType_inout);
}
function MsgSortByInoutaddress()
{
    MsgSortThreadPane(MsgViewSortType_inoutaddress);
}

/*
 * the following functions overload functions in threadPane.js
 * the call nsIMsgDbView.sort which we can't use because
 *  - the sort key length is determined depending on the sortType
 *  - the value is directly take from the messageheader with the
 *    sortType used as indicator
 *
 * Unfortunately, dbview.sortOrder is readonly, so i have to deal
 * with my own version.
 */
/*v sort does not work :-(((
function MsgSortThreadPane(sortType)
{
dump('SORT ThreadPane\n');
  if (sortType!=MsgViewSortType_inout &&
      sortType!=MsgViewSortType_inoutaddress)
    savedMsgSortThreadPane(sortType);
  else {
    mySort(sortType, nsMsgViewSortOrder.ascending);
    savedMsgSortThreadPane(sortType,nsMsgViewSortOrder.ascending);
    var dbview = GetDBView();
dumpTree();
    dbview.sortType=sortType;
//    dbview.sortOrder=nsMsgViewSortOrder.ascending;
    UpdateSortIndicators(sortType, nsMsgViewSortOrder.ascending);
  }
}
function MsgToggleThreaded()
{
dump('SORT Toggle Thread\n');
  var dbview = GetDBView();
  if (dbview.sortType!=MsgViewSortType_inout &&
      dbview.sortType!=MsgViewSortType_inoutaddress)
    savedMsgToggleThreaded()
  else {
    savedMsgToggleThreaded()
    if (dbview.sortOrder==nsMsgViewSortOrder.ascending)
      sortOrder=nsMsgViewSortOrder.descending;
    else
      sortOrder=nsMsgViewSortOrder.ascending
//My Own sort
    dbview.sortOrder=sortOrder;
    UpdateSortIndicators(dbview.sortType,sortOrder);
  }
}
^*/

/*
 * The next two functions probably need not be overloaded
 * it seems that its can be assumed that its already sorted
 * and the sort is just reversed
 */
/*
function MsgSortAscending()
{
dump('SORT Ascending\n');
  var dbview = GetDBView();
  if (dbview.sortType!=MsgViewSortType_inout &&
      dbview.sortType!=MsgViewSortType_inoutaddress)
    savedMsgSortAscending()
  else {
//My Own sort
    savedMsgSortAscending()
//    dbview.sortOrder=nsMsgViewSortOrder.ascending;
    UpdateSortIndicators(dbview.sortType, nsMsgViewSortOrder.ascending);
  }
}
function MsgSortDescending()
{
dump('SORT Descending\n');
  var dbview = GetDBView();
  if (dbview.sortType!=MsgViewSortType_inout &&
      dbview.sortType!=MsgViewSortType_inoutaddress)
    savedMsgSortDescending()
  else {
//My Own sort
    savedMsgSortDescending()
//    dbview.sortOrder=nsMsgViewSortOrder.descending;
    UpdateSortIndicators(dbview.sortType, nsMsgViewSortOrder.descending);
  }
}
*/

function mySort(sortType, sortOrder) {
  var dbview = GetDBView();
dump('mySort: usingLines='+dbview.rowCount +'\n');
  if (sortType==MsgViewSortType_inoutaddress) {
    var arr=new Array;
    var count=dbview.rowCount;
    for (row=0; row<count ; row++) {
      var key=dbview.getKeyAt(row);
      if (sioData[key] === undefined)
        getMsgInfo(row, key);
      arr.push(sioAddr[key]+'|'+row);
      arr[sioAddr[key]+'|'+row]=row;
    }
    var sortF=sortOrder==nsMsgViewSortOrder.ascending ?
      function(a,b) { return a.toLowerCase() < b.toLowerCase()?-1:1 } :
      function(a,b) { return a.toLowerCase() > b.toLowerCase()?-1:1 }
    arr.sort(sortF);
  // Must sort TB internal array m_keys, m_flags indexed by row
  // and sort the folders (as nsICollection)
    var supports=Components.classes["@mozilla.org/supports-array;1"].
      createInstance(Components.interfaces.nsICollection);
    var folder=dbview.viewFolder.QueryInterface(Components.interfaces.nsICollection);
    for (row = 0; row < count; row++) {
      var p=arr[row].indexOf('|');
      var ind=Number(arr[row].substr(p+1));
//dump(arr[row]+' '+ind+' '+typeof(ind)+'\n');
      supports.AppendElement(folder.GetElementAt(ind));
    }
//SetElementAt throws exception :-)
//    folder.Clear();
    for (row = 0; row < count; row++) {
//      folder.SetElementAt(row, supports.GetElementAt(row));
//var x=supports.GetElementAt(row).QueryInterface(Components.interfaces.nsIMsgDBHdr);
//dump(row+': '+x.mime2DecodedAuthor+'\n');
//      folder.AppendElement(supports.GetElementAt(row));
    }
  }
}

setTimeout(sio_init, 1000);

function dumpTree() {
  var tree=document.getElementById('threadTree');
//  dump('DOM: '+tree.tagName+'\n');
  var rows=tree.firstChild.nextSibling; //treechildren, nicht xul:treerows!!!
  //rows.firstChild: ex. nicht!
  //rows.childNodes.length=0 !!!
}

